/*======================================================================*\
|| #################################################################### ||
|| # Lorkan Search Box Ver. 1.0 						    #	||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2003-2004 Lorkan Themes. All Rights Reserved.	    # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # --------------------------- SEARCH BOX ------------------------- # ||
|| # http://www.lorkan.com | Simply The Best Themes for Nuke	    # ||
|| #################################################################### ||
\*======================================================================*/

var lkmenu_usepopups = true;
var lkmenu_registered = new Array();
var lkmenu_initialized = new Array();
var lkmenu_activemenus = new Array();
var lkmenu_currentactive = false;
var slidetimer = false;
var lkmenu_opensteps = 10;
var lkmenu_doslide = true;
var lkmenu_dofade = false; // can be very slow

var lkmenu_datefields = new Array();

// #############################################################################
// another function to handle the different event models of different browsers
// and prevent event bubbling in a lesser way
function e_by_gum(eventobj)
{
	if (!eventobj || is_ie)
	{
		window.event.cancelBubble = true;
		return window.event;
	}
	else
	{
		if (eventobj.target.type == 'submit')
		{
			// naughty safari
			eventobj.target.form.submit();
		}
		eventobj.stopPropagation();
		return eventobj;
	}
}

// #############################################################################
// get left position of elm
function fetch_object_posleft(elm)
{
	var left = elm.offsetLeft;
	while((elm = elm.offsetParent) != null)
	{
		left += elm.offsetLeft;
	}
	return left;
}

// #############################################################################
// get top position of elm
function fetch_object_postop(elm)
{
	var top = elm.offsetTop;
	while((elm = elm.offsetParent) != null)
	{
		top += elm.offsetTop;
	}
	return top;
}

// #############################################################################
function lkmenu_doregister(controlid, nowrite, datefield)
{
	if (document.getElementsByTagName)
	{
		controlobj = fetch_object(controlid);
		if (controlobj)
		{			
			if (datefield)
			{
				lkmenu_datefields[controlid] = datefield;
			}
			
			lkmenu_registered[lkmenu_registered.length] = controlid;
			
			if (!nowrite)
			{
			}
			return true;
		}
	}
	
	return false;
}

// #############################################################################
// function to get the menu basename - 'menu.104' returns 'menu', 'x.menu' returns 'x'
function lkmenu_getmenuid(controlid)
{
	dotpos = controlid.indexOf(".");
	if (dotpos != -1)
	{
		return controlid.substr(0, dotpos);
	}
	else
	{
		return controlid;
	}
}

// #############################################################################
// handle menu control mouseover events
function lkmenu_eventhandler_mouseover(e)
{
	e = do_an_e(e);
	lkmenu_hover(this);
}

// #############################################################################
// handle menu control click events
function lkmenu_eventhandler_click(e)
{
	e = do_an_e(e);
	lkmenu_open(this);
}

// #############################################################################
// close all open menus
function lkmenu_close()
{
	if (lkmenu_currentactive)
	{
		for (key in lkmenu_activemenus)
		{
			fetch_object(lkmenu_getmenuid(key) + "_menu").style.display = "none";
			lkmenu_activemenus[key] = false;
		}
	}
	lkmenu_currentactive = false;
	
	if (slidetimer)
	{
		clearTimeout(slidetimer);
		slidetimer = false;
	}
	
	if (is_ie)
	{
		selects = document.getElementsByTagName("select");
		for (var i = 0; i < selects.length; i++)
		{
			selects[i].style.visibility = "visible";
		}
	}
}

// #############################################################################
// open menu under pointer if another menu is active
function lkmenu_hover(elm)
{
	for (key in lkmenu_activemenus)
	{
		if (lkmenu_activemenus[key] == true && key != elm.id)
		{
			lkmenu_open(elm);
			return;
		}
	}
}

// #############################################################################
// detect if selectobj overlaps m
function lkmenu_overlap(selectobj, m)
{
	s = new Array();
	s['L'] = fetch_object_posleft(selectobj);
	s['T'] = fetch_object_postop(selectobj);	
	s['R'] = s['L'] + selectobj.offsetWidth;
	s['B'] = s['T'] + selectobj.offsetHeight;
	
	if (s['L'] >= m['L'] && s['L'] <= m['R'] && ((s['T'] >= m['T'] && s['T'] <= m['B']) || (s['B'] >= m['T'] && s['B'] <= m['B']))) { return true; }
	else if (s['R'] >= m['L'] && s['R'] <= m['R'] && ((s['T'] >= m['T'] && s['T'] <= m['B']) || (s['B'] >= m['T'] && s['B'] <= m['B']))) { return true; }
	else if (s['B'] >= m['T'] && s['T'] <= m['B'] && ((s['L'] >= m['L'] && s['L'] <= m['R']) || (s['R'] >= m['R'] && s['R'] <= m['R']))) { return true; }
	else if (m['B'] >= s['T'] && m['T'] <= s['B'] && ((m['L'] >= s['L'] && m['L'] <= s['R']) || (m['R'] >= s['R'] && m['R'] <= s['R']))) { return true; }
	else { return false; }
}

// #############################################################################
// open the clicked menu
function lkmenu_open(elm)
{
	openmenu = lkmenu_currentactive;
	
	lkmenu_close();
	
	if (openmenu == elm.id)
	{
		// clicked element was the control for the currently open menu - exit
		return false;
	}
	
	// get the id of the menu to be opened
	menuid = lkmenu_getmenuid(elm.id) + "_menu";	
	menuobj = fetch_object(menuid);
	
	if (lkmenu_datefields[elm.id])
	{
		force_right_slide = true;
		fetch_object(elm.id + "_output").innerHTML = fetch_object(lkmenu_datefields[elm.id]).value;
	}
	else
	{
		force_right_slide = false
	}
	
	lkmenu_activemenus[elm.id] = true;
	lkmenu_currentactive = elm.id;
	
	// get menu position
	leftpx = fetch_object_posleft(elm);
	toppx = fetch_object_postop(elm) + elm.offsetHeight;
	
	// un-hide menu	
	menuobj.style.display = "";
	
	// attempt to keep menu on screen
	if (force_right_slide || (leftpx + menuobj.offsetWidth) >= document.body.clientWidth)
	{
		leftpx = leftpx + elm.offsetWidth - menuobj.offsetWidth;
		slidedir = "right";
	}
	else
	{
		slidedir = "left";
	}

	// shuffle the IE menus a bit
	if (is_ie)
	{
		leftpx += (slidedir == "left") ? -2 : 2;
	}
	
	// set menu position
	menuobj.style.left = leftpx + "px";
	menuobj.style.top = toppx + "px";
	
	if (is_ie)
	{	
		menuarea = {
			"L" : leftpx,
			"T" : toppx,
			"R" : leftpx + menuobj.offsetWidth,
			"B" : toppx + menuobj.offsetHeight
		};		
		selects = document.getElementsByTagName("select");
		for (var i = 0; i < selects.length; i++)
		{
			if (lkmenu_overlap(selects[i], menuarea))
			{
				selects[i].style.visibility = "hidden";
			}
		}
	}

	// slide menus open (internet explorer only)
	if (lkmenu_doslide && !is_opera && !is_ie4)
	{
		if (lkmenu_dofade && is_ie)
		{
			menuobj.filters.item('DXImageTransform.Microsoft.alpha').opacity = 0;
		}
		
		intervalX = Math.ceil(menuobj.offsetWidth / lkmenu_opensteps);
		intervalY = Math.ceil(menuobj.offsetHeight / lkmenu_opensteps);
		
		if (slidedir == "left")
		{
			menuobj.style.clip = "rect(auto, 0px, 0px, auto)";
			lkmenu_slide_left(menuid, intervalX, intervalY, 0, 0, 0);
		}
		else
		{
			menuobj.style.clip = "rect(auto, auto, 0px, " + (menuobj.offsetWidth) + "px)";
			lkmenu_slide_right(menuid, intervalX, intervalY, menuobj.offsetWidth, 0, 0);
		}
	}
	
	return false;
}

// #############################################################################
// internet explorer slide menu open left
function lkmenu_slide_left(menuid, intervalX, intervalY, clipX, clipY, opacity)
{
	menuobj = fetch_object(menuid);
	
	if (clipX < menuobj.offsetWidth || clipY < menuobj.offsetHeight)
	{
		if (lkmenu_dofade && is_ie)
		{
			opacity += 10;
			menuobj.filters.item('DXImageTransform.Microsoft.alpha').opacity = opacity;
		}
		clipX += intervalX;
		clipY += intervalY;
		menuobj.style.clip = "rect(auto, " + clipX + "px, " + clipY + "px, auto)";
		slidetimer = setTimeout("lkmenu_slide_left('" + menuid + "', " + intervalX + ", " + intervalY + ", " + clipX + ", " + clipY + ", " + opacity + ");", 0);
	}
	else
	{
		clearTimeout(slidetimer);
	}
}

// #############################################################################
// internet explorer slide menu open right
function lkmenu_slide_right(menuid, intervalX, intervalY, clipX, clipY, opacity)
{
	menuobj = fetch_object(menuid);
	
	if (clipX > 0 || clipY < menuobj.offsetHeight)
	{
		if (lkmenu_dofade && is_ie)
		{
			opacity += 10;
			menuobj.filters.item('DXImageTransform.Microsoft.alpha').opacity = opacity;
		}
		clipX -= intervalX;
		clipY += intervalY;
		menuobj.style.clip = "rect(auto, " + menuobj.offsetWidth + "px, " + clipY + "px, " + clipX + "px)";
		slidetimer = setTimeout("lkmenu_slide_right('" + menuid + "', " + intervalX + ", " + intervalY + ", " + clipX + ", " + clipY + ", " + opacity + ");", 0);
	}
	else
	{
		clearTimeout(slidetimer);
	}
}

// #############################################################################
// function to navigate to the href of the first found <a> tag
function lkmenu_navtolink(e)
{
	childLinks = this.getElementsByTagName("a");
	if (childLinks[0])
	{
		if (is_ie)
		{
			// use this in IE to send HTTP_REFERER
			childLinks[0].click();
			window.event.cancelBubble = true;
		}
		else
		{
			// other browsers can use this
			if (e.shiftKey)
			{
				window.open(childLinks[0].href);
				e.stopPropagation();
				e.preventDefault();
				return false;
			}
			else
			{
				window.location = childLinks[0].href;
				e.stopPropagation();
				e.preventDefault();
				return false;
			}
		}
	}
}

// #############################################################################
// function to toggle the background class of a menu option
function lkmenu_switch_option_bg(e)
{
	this.className = (this.className == "lkmenu_option") ? "lkmenu_hilite" : "lkmenu_option";
	lkmenu_hand_pointer(this);
}

// #############################################################################
// function to set the cursor to be pointer/hand
function lkmenu_hand_pointer(obj)
{
	try
	{
		obj.style.cursor = "pointer";
	}
	catch(e)
	{
		obj.style.cursor = "hand";
	}
}

// #############################################################################
// function to initialize a single menu entry
function lkmenu_init(controlid)
{
	menuid = lkmenu_getmenuid(controlid) + "_menu";
	menuobj = fetch_object(menuid);
	
	if (document.getElementsByTagName && menuobj)
	{
		// do control object
		controlobj = fetch_object(controlid);
		lkmenu_hand_pointer(controlobj);
		controlobj.unselectable = true;
		controlobj.onclick = lkmenu_eventhandler_click;
		controlobj.onmouseover = lkmenu_eventhandler_mouseover;
		
		// don't initialize the same popup menu twice
		if (lkmenu_initialized[menuid])
		{
			return;
		}
		
		// do popup menu object
		popupobj = fetch_object(menuid);
		popupobj.style.display = "none";
		popupobj.style.position = "absolute";
		popupobj.style.left = "0px";
		popupobj.style.top = "0px";
		popupobj.onclick = e_by_gum;
		
		// reset inner table width
		tables = popupobj.getElementsByTagName("table");
		if (tables.length > 0)
		{
			tables[0].width = "";
		}
		
		// init popup filters (ie only)
		if (is_ie)
		{		
			popupobj.style.filter += "progid:DXImageTransform.Microsoft.alpha(enabled=1,opacity=100)";
			popupobj.style.filter += "progid:DXImageTransform.Microsoft.shadow(direction=135,color=#9B9B9B,strength=7)";
		}
		
		// do menu options
		tds = popupobj.getElementsByTagName("td");
		for (var i = 0; i < tds.length; i++)
		{			
			if (tds[i].className == "lkmenu_option")
			{
				tds[i].style.cursor = "default";
				if (tds[i].title == "nohilite")
				{
					tds[i].title = "";
				}
				else
				{
					tds[i].onmouseover = lkmenu_switch_option_bg;
					tds[i].onmouseout = lkmenu_switch_option_bg;
					tds[i].onclick = lkmenu_navtolink;
					
					// prevent links from executing twice
					/*if (is_moz)
					{
						try
						{
							links = tds[i].getElementsByTagName("a");
							for (var j = 0; j < links.length; j++)
							{
								links[j].onclick = returnfalse;
							}
						}
						catch(e)
						{
							// nuffink
						}
					}*/
					if (!is_saf && !is_kon)
					{
						try
						{
							links = tds[i].getElementsByTagName("a");
							for (var j = 0; j < links.length; j++)
							{
								if (!links[j].onclick)
								{
									links[j].onclick = e_by_gum;
								}
							}
						}
						catch(e)
						{
							// hmm
						}
					}
				}
			}
		}
		
		lkmenu_initialized[menuid] = true;
	}
}

function returnfalse()
{
	return false;
}

